
#include "AboutWindow.h"
#include "AboutView.h"
#include "JView.h"
#include "JVConstants.h"
#include "FileEntry.h"
#include <Button.h>


#pragma mark ## MAIN

main(int argc, char **)
{	
	JViewApplication *myApplication;
	
	if (argc == 1) {
		printf("Usage: JView <files>\n");
		return(10);
	}
	
	myApplication = new JViewApplication();
	myApplication->Run();
	
	delete(myApplication);
	return(0);
}

#pragma mark ## APPLICATION

JViewApplication::JViewApplication() : BApplication('JViw') {
}


//
// Create list of files to be shown
//
void
JViewApplication::ArgvReceived(int argc, char ** argv) {
	int i;
	FileEntry *entry;
	
	for (i=1; i < argc; i++) {
		entry = new FileEntry(argv[i]);
		file_list.AddItem(entry);
	}
}


//
// Add buttons and request first image to be shown.
//
void
JViewApplication::ReadyToRun() {
	BRect rect;
	JViewView *view;
	
	// Set up a rectangle and instantiate a new window
	rect.Set(5, 5, 150, 100);
	window = new JViewWindow(rect, &file_list);
	
	// Set up a rectangle and instantiate a new view. The view rect
	// should be the same size as the window rect but with left-top
	// at (0,0).
	rect.OffsetTo(B_ORIGIN);
	view = new JViewView(rect, "JViewView");
	
	// Add view to window
	window->AddChild(view);
	
	// Make window visible
	window->Show();

}


void
JViewApplication::MessageReceived(BMessage *message) {
	if (message->what == FINISHED)
		window->MessageReceived(message);
	else
		BApplication::MessageReceived(message);
}


void
JViewApplication::AboutRequested() {
	AboutWindow *window;
	AboutView *view;
	BRect rect;
	
	rect.Set(50, 50, 550, 150);
	window = new AboutWindow(rect);
	
	rect.OffsetTo(B_ORIGIN);
	view = new AboutView(rect);
	
	window->AddChild(view);
	
	window->Show();
}
