#ifndef JVIEWWINDOW_H
#define JVIEWWINDOW_H

#include <Window.h>
#include <List.h>
#include <Button.h>
#include <StringView.h>

class JViewWindow : public BWindow {
private:
	BList *entry_list;
	int current;	// index of entry being displayed
	int conv_index;	// index being or next to be converted
	
	// Converter thread and routines
	thread_id conv_thread;
	static long entry_func(void *arg);
	long converter();
	
	// GUI elements
	BButton *next_button;
	BButton *del;
	BStringView *label;
	
public:
	JViewWindow(BRect frame, BList *files);
	virtual bool QuitRequested();
	virtual void MessageReceived(BMessage *message);
	virtual bool FilterKeyDown(ulong *aChar, BView **target);
	void Draw(bool resize);
};

#endif
